<?php

// Language definitions used in delete.php
$lang_install = array(

// Install Form
'Install PunBB'				=>	'Install PunBB %s',
'Required'					=>	'(Required)',
'Install welcome'			=>	'Welcome to PunBB installation. You are about to install PunBB %s.',
'Install head'				=>	'Complete all three parts of this form to install your forum',
'Install intro'				=>	'In order to install PunBB you must complete the form set out below. Please read the instructions provided before completing the form. If you encounter any difficulties with the installation, please refer to the documentation supplied as part of PunBB\'s download package.',
'Part1'						=>	'Part 1 - Database setup',
'Part1 intro'				=>	'Please enter the requested information in order to setup your database for PunBB. You must know all the information asked for before proceeding with the installation. Help with completing this part of the form is set out below.',
'Database type'				=>	'Database type:',
'Database name'				=>	'Database name:',
'Database server'			=>	'Database server:',
'Database username'			=>	'Database username:',
'Database password'			=>	'Database password:',
'Database user pass'		=>	'Database username and password:',
'Table prefix'				=>	'Table prefix:',
'Database type info'		=>	'PunBB currently supports MySQL, PostgreSQL and SQLite. If your database of choice is missing from the drop-down menu below, it means this PHP environment does not have support for that particular database. More information regarding support for particular versions of each database can be found in the FAQ.',
'Mysql type info'			=>	'PunBB has detected that your PHP environment supports two different ways of communicating with MySQL. The two options are called "<em>standard</em>" and "<em>improved</em>". If you are uncertain which one to use, start by trying improved and if that fails, try standard.',
'Database server info'		=>	'Enter the address of the database server (example: <em>localhost</em>, <em>db.myhost.com</em> or <em>192.168.0.15</em>). You can specify a custom port number if your database doesn\'t run on the default port (example: <em>localhost:3580</em>). For SQLite support, just enter anything or leave it at \'localhost\'.',
'Database name info'		=>	'Enter the name of the database that PunBB will be installed into. The database must exist. For SQLite, this is the relative path to the database file. If the SQLite database file does not exist, PunBB will attempt to create it.',
'Database username info'	=>	'Enter the username and password used for connecting to the selected database. Ignore for SQLite.',
'Table prefix info'			=>	'Optional - enter a database table prefix. By specifying a table prefix you can run multiple copies of PunBB in the same database (example: <em>foo_</em>).',
'Part1 legend'				=>	'Database information',
'Database type help'		=>	'Select type of database.',
'Database server help'		=>	'The address of your database server. For SQLite enter anything.',
'Database name help'		=>	'Existing database PunBB will be installed to.',
'Database username help'	=>	'For database connection. Ignore for SQLite.',
'Database password help'	=>	'For database connection. Ignore for SQLite.',
'Table prefix help'			=>	'Optional database table prefix e.g. "foo_".',
'Part2'						=>	'Part 2 - Forum Administrator setup',
'Part2 legend'				=>	'Administrator\'s details',
'Part2 intro'				=>	'Please enter the requested information in order to setup an administrator for your PunBB installation. You can later create more administrators and moderators.',
'Username'					=>	'Username:',
'Password'					=>	'Password:',
'E-mail address'			=>	'E-mail address:',
'Admin username'			=>	'Administrator\'s username:',
'Admin password'			=>	'Administrator\'s password:',
'Admin confirm password'	=>	'Confirm password:',
'Admin e-mail'				=>	'Administrator\'s e-mail:',
'Admin username info'		=>	'Enter the username of the forum administrator. Usernames can be between 2 and 25 characters long.',
'Admin password info'		=>	'Enter then re-enter the forum administrator\'s password. Passwords must be at least 4 characters long and are case sensitive.',
'Admin e-mail info'			=>	'Enter a current and valid e-mail address for the forum administrator.',
'Username help'				=>	'Between 2 and 25 characters.',
'Password help'				=>	'Minimum 4 characters. Case sensitive.',
'Confirm password help'		=>	'Re-enter exactly as before.',
'E-mail address help'		=>	'The e-mail address of the forum administrator.',
'Part3'						=>	'Part 3 - Forum setup',
'Part3 legend'				=>	'Forum information',
'Part3 intro'				=>	'Please enter the requested information. Pay particular attention to entering your base URL and read the instructions set out below carefully.',
'Board title'				=>	'Board title:',
'Board title and desc'		=>	'Board title and description:',
'Board description'			=>	'Board description:',
'Base URL'					=>	'Base URL:',
'Board title info'			=>	'Enter a title and a short description for your PunBB installation. They will be shown at the top of every page. Leave blank to use the default title and description. Both can be changed later.',
'Base URL info'				=>	'Please pay particular attention when entering your Base URL. You must set the correct Base URL or your forum will not work properly. The Base URL is the URL (without trailing slash) of your PunBB forum (example: <em>http://forum.myhost.com</em> or <em>http://myhost.com/~myuser</em>). Please note that the preset value below is just an educated guess by PunBB.',
'Base URL help'				=>	'The URL (without trailing slash) of your PunBB installation. Please read information above.',
'Start install'				=>	'Start install', // Label for submit button

// Installation completed form
'Success description'		=>	'Congratulations! PunBB %s has been successfully installed.',
'Success welcome'			=>	'Please follow the instructions below to finalize the installation.',
'Final instructions'		=>	'Final instructions',
'No write info 1'			=>	'Important! To finalize the installation, you need to click on the button below to download a file called config.php. You then need to upload this file to the root directory of your PunBB installation.',
'No write info 2'			=>	'Once you have uploaded config.php, PunBB will be fully installed! You may then %s once config.php has been uploaded.',
'Go to index'				=>	'go to the forum index',
'Warning'					=>	'Warning!',
'No cache write'			=>	'<strong>The cache directory is currently not writable!</strong> In order for PunBB to function properly, the directory named <em>cache</em> must be writable by PHP. Use chmod to set the appropriate directory permissions. If in doubt, chmod to 0777.',
'No avatar write'			=>	'<strong>The avatar directory is currently not writable!</strong> If you want users to be able to upload their own avatar images you must see to it that the directory named <em>img/avatars</em> is writable by PHP. You can later choose to save avatar images in a different directory (see Admin/Options). Use chmod to set the appropriate directory permissions. If in doubt, chmod to 0777.',
'File upload alert'			=>	'<strong>File uploads appear to be disallowed on this server!</strong> If you want users to be able to upload their own avatar images you must enable the file_uploads configuration setting in PHP. Once file uploads have been enabled, avatar uploads can be enabled in Administration / Options / Content.',
'Download config'			=>	'Download config.php file', // Label for submit button
'Write info'				=>	'PunBB has been fully installed! You may now %s.',
);